#include <fstream>

using namespace std;
ifstream fin("p_order.in");
ofstream fout("p_order.out");
#define modulo 666013
long long a[600010];
long long putere( long long a, long long n)
{
    if (n==0)
        return 1;
    else
    {
        long long x=putere(a,n/2);
        if (n%2)
            return (((a*x)% modulo) * x) % modulo;
        else
            return (x*x)% modulo;
    }
}

long long fact(long long n)
{
    long long p=1;
    for (long long i=2; i<=n; i++)
        p=(p*i) % modulo;
    return p;
}

long long comb(long long n,long long k)
{
    long long numarator=fact(n);
    long long numitor=(fact(k)*fact(n-k))% modulo;
    return (numarator*putere(numitor,modulo-2))% modulo;
}

void subprobleme (int n, int p, long long &k1, long long &n1, long long &k2, long long &n2, long long &k3, long long &n3)
{
    long long s=0;
    long long termen=1;
    while (s+termen+termen*p<n)
    {
        s+=termen;
        termen*=p;
    }
    n1=s+termen;
    k1=(n-s-termen)/termen;
    k2=0;
    n2=0;
    n3=s;
    k3=p-k1;
    if (k1*n1+k3*n3!=n-1)
    {
        n2=n3+ n-1 - k1*n1-k3*n3;
        k2=1;
        k3--;
    }

}
long long numar(long long n, long long p)
{
    long long n1,n2,n3,k1,k2,k3;
    if (n==1 or n==0)
        return 1;
    else
    {
        if (a[n]!=-1)
            return a[n];
        subprobleme(n,p,k1,n1,k2,n2,k3,n3);   /// k1+k2+k3=p
            /// avem k1 subarbori completi mari
            /// avem k2=(0 sau 1) arbore aproape complet
            /// avem k3 subarbori completi mici

        a[n]=1;
        for (int i=1;i<=k1;i++)
            a[n]=(a[n]*(comb(n-1-(i-1)*n1,n1)*numar(n1,p))% modulo)% modulo;
        for (int i=1;i<=k2;i++)
        {
            long long x=comb(n-1-k1*n1,n2);
            long long y=numar(n2,p);
            a[n]=(a[n]*(x*y)% modulo)% modulo;

        }
        for (int i=1;i<=k3;i++)
            a[n]=(a[n]*(comb(n-1-k1*n1-k2*n2-(i-1)*n3,n3)*numar(n3,p))% modulo)% modulo;
        return a[n];
    }
}

int main()
{
    long long n,p;
    for (int j=1;j<=10;j++)
    {
        fin>>n>>p;
        for (int i=1;i<=n;++i)
            a[i]=-1;
        fout<<numar(n,p)<<"\n";
    }
    return 0;
}
