#include <stdlib.h>
#include <string.h>
#include <stdio.h>

typedef struct { int k,o; char S[8],N[36]; } Ipers;
Ipers Pers[200000], *Pa, *Pp;
int np;

int cmpK(const void *A, const void *B) {
Ipers *P = (Ipers *)A, *Q = (Ipers *)B;
int d;
if (d=P->k-Q->k) return d;
return P->o - Q->o;
}

int cmpA(const void *A, const void *B) {
Ipers *P = (Ipers *)A, *Q = (Ipers *)B;
return strcmp(P->N,Q->N); 
}

void Read() {
FILE *Fi;
int i;
Fi = fopen("X.in","r"); fscanf(Fi,"%d",&np);
Pp = Pers; i = 0;
do {
   if (fscanf(Fi,"%d %s %[^\n]",&Pp->k,Pp->S,Pp->N)<0) break;
   Pp->o = i; Pp++; i++;
   } while (1);
fclose(Fi); qsort(Pers,np,sizeof(Ipers),cmpK);
Pa = Pers; Pp = Pa + 1;
for (i=1; i<np; i++,Pp++) {
    if (Pp->k!=Pa->k) Pa++;
    memcpy(Pa,Pp,sizeof(Ipers));
    }
np = (Pa - Pers) + 1;
}

void Count() {
int i,na,nb,nc,nd;
Pp = Pers; na = nb = nc = nd = 0;
for (i=0; i<np; i++,Pp++) if (Pp->S[1]!='-') {
    if (Pp->S[0]=='M') na++;
    if (Pp->S[0]=='F') nb++;
    if (strchr(Pp->S,'C')) nc++;
    if (strchr(Pp->S,'S')) nd++;
    }
printf("%d men\n%d women\n%d computer scientists\n%d for secret service\n\n",na,nb,nc,nd);
}

void Display() {
int i;
Pa = Pp = Pers;
for (i=0; i<np; i++,Pp++) if (Pp->S[1]!='-')
    if (strchr(Pp->S,'C')) if (strchr(Pp->S,'S'))
       memcpy(Pa++,Pp,sizeof(Ipers));
np = Pa - Pers;
qsort(Pers,np,sizeof(Ipers),cmpA);
for (i=0,Pp=Pers; i<np; i++,Pp++)
    printf("%d %s %s\n",Pp->k,Pp->S,Pp->N);
}

int main() {
Read(); Count(); Display();
return 0;
}
